﻿'程序目标：
'1、实现棋型评价函数。

Public Class Form1
    '黑白棋子
    Private bb As Bitmap
    Private bw As Bitmap
    '棋子偏移
    Private co As Point = New Point(5, 5)
    '棋子大小
    Private cs As Size = New Size(25, 25)
    '位棋盘
    Private ucpcSquares As mBitBoard

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        '初始化棋盘背景
        pnlBoard.BackgroundImage = My.Resources._2064
        '初始化棋子
        Dim resbmp As Bitmap = New Bitmap(My.Resources._7041, cs.Width * 4, cs.Height)
        Dim allbmp As Bitmap = New Bitmap(resbmp.Width \ 2, resbmp.Height)
        '获取棋子图像
        For y As Integer = 0 To allbmp.Height - 1
            For x As Integer = 0 To allbmp.Width - 1
                If resbmp.GetPixel(x + allbmp.Width, y).ToArgb = Color.Black.ToArgb Then allbmp.SetPixel(x, y, resbmp.GetPixel(x, y))
            Next
        Next
        bb = allbmp.Clone(New Rectangle(0, 0, allbmp.Width / 2, allbmp.Height), allbmp.PixelFormat)
        bw = allbmp.Clone(New Rectangle(allbmp.Width / 2, 0, allbmp.Width / 2, allbmp.Height), allbmp.PixelFormat)
        '==========================开局棋型可在这里设置==============================
        ucpcSquares = New mBitBoard()
        ucpcSquares.Set(7 * 15 + 7, 1)
    End Sub

    '绘制棋子
    Private Sub pnlBoard_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles pnlBoard.Paint
        For i As Integer = 0 To 224
            If ucpcSquares.Get(i) = 1 Then e.Graphics.DrawImage(bb, New Point((i Mod 15) * cs.Height, (i \ 15) * cs.Height) + co)
            If ucpcSquares.Get(i) = 0 Then e.Graphics.DrawImage(bw, New Point((i Mod 15) * cs.Height, (i \ 15) * cs.Height) + co)
        Next
    End Sub

    '用于测试棋型评价函数，后面版本会删除==============================================================
    Dim mvs As New mVectors
    '用于测试棋型评价函数，后面版本会删除==============================================================

    '下子
    Private Sub pnlBoard_MouseDown(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles pnlBoard.MouseDown
        Dim sdr = CType(sender, Panel)
        '鼠标坐标转棋盘坐标
        Dim p As Point = e.Location - co
        p.X \= cs.Width
        p.Y \= cs.Height
        '下一个白子
        If e.Button = Windows.Forms.MouseButtons.Left Then
            ucpcSquares.Set(p.Y * 15 + p.X, 0)
            '用于测试棋型评价函数，后面版本会删除==============================================================
            For Each mv As mVector In mvs.hs(p.Y * 15 + p.X)
                mv.update = True
            Next
        ElseIf e.Button = Windows.Forms.MouseButtons.Right Then
            ucpcSquares.Set(p.Y * 15 + p.X, 1)
            For Each mv As mVector In mvs.hs(p.Y * 15 + p.X)
                mv.update = True
            Next
        Else
            Debug.Print(mvs.Evaluate(ucpcSquares, 1, 2))
            For i As Integer = 0 To mvs.lnkinf.Count - 1
                For j As Integer = 0 To mvs.lnkinf(i).cqpend
                    Debug.Print(mvs.lnkinf(i).cqp(j) \ 15 & " " & mvs.lnkinf(i).cqp(j) Mod 15)
                Next
            Next
            '用于测试棋型评价函数，后面版本会删除==============================================================
        End If
        '更新显示
        pnlBoard_Paint(sdr, New PaintEventArgs(sdr.CreateGraphics, sdr.DisplayRectangle))
    End Sub

End Class
